
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Green
#property indicator_color2     Coral
#property indicator_color3     Aqua
#property indicator_color4     Red
#property indicator_width1     3
#property indicator_width2     3
#property indicator_width3     1
#property indicator_width4     1
#property indicator_levelcolor MediumOrchid
//
//
//
//
//

extern int    FastMaPeriod    = 8;
extern int    FastMaMode      = 1;
extern int    FastMaPrice     = 0;
extern int    SlowMaPeriod    = 17;
extern int    SlowMaMode      = 1;
extern int    SlowMaPrice     = 0;
extern int    SignalMaPeriod  = 9;
extern int    SignalMaMode    = 1;
extern double upperLevel      = 0.0015;
extern double lowerLevel      = -0.0015;

extern bool   alertsOn        = true;
extern bool   alertsOnSlope   = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";

//
//
//
//
//

double osma[];
double osmaUp[];
double osmaDn[];
double macd[];
double sig[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,osmaUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,osmaDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macd);
   SetIndexBuffer(3,sig);
   SetIndexBuffer(4,osma);
   SetIndexBuffer(5,trend1);
   SetIndexBuffer(6,trend2);
   SetLevelValue(0,upperLevel);
   SetLevelValue(1,lowerLevel);
   
   FastMaPeriod   = MathMax(FastMaPeriod,1);
   SlowMaPeriod   = MathMax(SlowMaPeriod,1);
   SignalMaPeriod = MathMax(SignalMaPeriod,1); 
   
   IndicatorShortName("MACD  ("+FastMaPeriod+","+SlowMaPeriod+","+SignalMaPeriod+")");
   return(0);
}

int deinit() { return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int start()
 {
   
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
    
   for(i=limit; i>=0; i--) macd[i] = iMA(NULL,0,FastMaPeriod,0,FastMaMode,FastMaPrice,i)-iMA(NULL,0,SlowMaPeriod,0,SlowMaMode,SlowMaPrice,i);
   for(i=limit; i>=0; i--) sig[i]  = iMAOnArray(macd,Bars,SignalMaPeriod,0,SignalMaMode,i);
   for(i=limit; i>=0; i--)
   {  
      osma[i]   = macd[i]-sig[i];
      osmaUp[i] = EMPTY_VALUE;        
      osmaDn[i] = EMPTY_VALUE;            
      trend1[i] = trend1[i+1];
      trend2[i] = trend2[i+1];
         if (osma[i] > 0)          trend1[i] =  1;
         if (osma[i] < 0)          trend1[i] = -1;
         if (osma[i] > upperLevel) trend2[i] =  1;
         if (osma[i] < lowerLevel) trend2[i] = -1;
         if (trend1[i] == 1)       osmaUp[i] = osma[i];  
         if (trend1[i] ==-1)       osmaDn[i] = osma[i];     
   }
     
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend2[whichBar] != trend2[whichBar+1])
     if (trend2[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");
   }      
return(0);
} 
        
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MACD 2 Color Histogram ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," MACD 2 Color Histogram " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MACD 2 Color Histogram "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}